<?php
// Size representative directory browser
// by mitxela
// www.mitxela.com

$cache="cache.txt";

if ($_SERVER["QUERY_STRING"]=="refresh") {
$structure=array();

function cacheDir($dir){
  global $structure;
  if (is_dir($dir)) {
    if ($dh = opendir($dir)) {
      while (($file = readdir($dh)) !== false) {
        if (filetype($dir . $file)=="dir" and $file!=".." and $file!=".") {
          $structure[$dir.$file]=get_size($dir . $file);
          cacheDir($dir . $file . "/");
        }
      }
      closedir($dh);
    }
  }
}

function get_size($path) {
  if(!is_dir($path)) return filesize($path);
  
  if ($handle = opendir($path)) {
    $size = 0;
    while (false !== ($file = readdir($handle))) {
      if($file!='.' && $file!='..') {
        $size+=get_size($path.'/'.$file);
      }
    }
    closedir($handle);
  }
  return $size;
}

cacheDir(realpath(".")."/");

$fh=fopen($cache,"w+");
foreach ($structure as $key => $value) {
  fwrite($fh,"$key = $value\n");
  echo "$key = $value<br/>"; // Just to let the user see it progressing - it can take a long time.
}

fclose($fh);
die("<script>window.location='".$_SERVER['HTTP_REFERER']."'</script>");
}

if (!file_exists($cache)) die("<script>window.location='?refresh'</script>");
$structure=parse_ini_file($cache);

$pre=realpath('.'); $dir=$_GET["dir"];
if (substr_count($dir,"..")) $dir="";
if (substr($dir, -1, 1) !== "/") $dir.="/";



if (is_dir($pre.$dir)) {
  if ($dh = opendir($pre.$dir)) {
    while (($file = readdir($dh)) !== false) {
      if ($file!="." and $file!="..") {
        if (filetype($pre.$dir . $file)=="dir") {
          $dirs[$file]=$structure[realpath($pre.$dir.$file)];
          $maxi=max($maxi,$dirs[$file]);
        } else {
          $files[$file]=filesize($pre.$dir.$file);
          $maxf=max($maxf,$files[$file]);
          
        }
      }
    }
    closedir($dh);
  }
}
?><style type="text/css">
a, a:visited, a:active {font-family:Arial; color:black; text-decoration:none; margin:10px;padding:0.2em; line-height:200%;}
a.d {background-color:#98bf21;}
a.d:hover {background-color:#7A991A;}
a.f:hover {text-decoration:underline;}
</style>
<div align="center">
<?php


echo "<big><a>[ ".realpath($pre.$dir)." ]</a> <a href='?dir=".preg_replace('/\w+\/\.\.\//', '', $dir."../")."'>[ Up ]</a> <a href='?refresh'>[ Refresh ]</a></big><br/><br/>";

if (isset($dirs))
 foreach ($dirs as $key => $value)
   echo "<a class='d' href='?dir=".preg_replace('/\w+\/\.\.\//', '', $dir.$key)."' title='".byteConvert($value)."' style='font-size:".round(14+60*$value/($maxi+1),2)."'>$key</a> ";
   
echo "<br/><br/>";

if (isset($files))
 foreach ($files as $key => $value)
  echo "<a class ='f' href='".substr($dir,1)."$key' title='".byteConvert($value)."' style='font-size:".round(14+40*$value/($maxf+1),2)."'>$key</a> ";

  
  
function byteConvert(&$bytes){
  $b = (int)$bytes;
  $s = array('B', 'kB', 'MB', 'GB', 'TB');
  if($b < 0){
    return "0 ".$s[0];
  }
  $con = 1024;
  $e = (int)(log($b,$con));
  return round($b/pow($con,$e),2).' '.$s[$e]; 
}


?></div>